<<* Proproc.inc *>>
 
<<procedure GenProcStandard>>
<<begin>>

* --- This procedure is called when Goto... is selected from the Go menu

PROCEDURE dogoto
where = 0
recnum = 0
okcancel = 0
getnum = .F.

* --- Define and activate Goto options

@ 1,2 SAY 'Goto: '
@ 0,10 TO 9,26
@ 1,13 PROMPT ' \<Top     '
@ 3,13 PROMPT ' \<Bottom  '
@ 5,13 PROMPT ' \<Record  '
@ 7,13 PROMPT ' \<Skip    '
MENU TO where
DO CASE															 

    *--- Escape out of dialog
    CASE where = 0
        RETURN

    *--- Goto first record
    CASE where = 1
        GO TOP

    *--- Goto last record
    CASE where = 2
        GO BOTTOM

    *--- Goto specified record number
    CASE where = 3
        recnum = 0 
        @ 5,29 GET recnum PICTURE '@Z 99999999'
        READ
        DEACTIVATE WINDOW ALL
        IF recnum < 1
            RETURN
        ENDIF
        IF recnum > RECCOUNT()
            DO alert WITH msg_range 
        ELSE
            GO recnum
        ENDIF

    *--- Skip specified number of records
    CASE where = 4
        recnum = 0 
        @ 7,29 GET recnum PICTURE '@Z 99999999'
        READ
        DEACTIVATE WINDOW ALL
        mrecno = RECNO() 
        SKIP recnum 
        IF EOF() .OR. BOF()
            DO alert WITH msg_range 
            GOTO mrecno
        ENDIF
ENDCASE
RETURN

* ---  This procedure is called to display a message 

PROCEDURE alert
PARAMETER mess
=SYS(2002)
ACTIVATE WINDOW alert
CLEAR
@ 2,0 SAY PADC(mess,WCOLS())
WAIT ''
DEACTIVATE WINDOW alert
=SYS(2002,1)
RETURN

* --- Procedure called when a Yes/No response is needed

PROCEDURE alert2
PARAMETER answer,mess1
ACTIVATE WINDOW alert
CLEAR
@ 1,0 SAY PADC(mess1,WCOLS())
DO WHILE .T. 
    @ 3,3 PROMPT '<   \<Yes    >'  
    @ 3,34 PROMPT CHR(174)+'    \<No    '+CHR(175) 
    MENU TO answer
    IF answer <> 0
        EXIT
    ENDIF
ENDDO       
DEACTIVATE WINDOW alert
RETURN

* --- Procedure called when a program is busy processing

PROCEDURE working
PARAMETER mstatus
IF mstatus
    SET BLINK ON
    SET COLOR TO &mflash
    @ 24,70 SAY ' Working..'
    SET COLOR TO 
ELSE
    SET BLINK OFF
    @ 24,70
ENDIF
RETURN
 
* --- Procedure called when the Locate option is selected from the Go menu

PROCEDURE dolocate
PARAMETER expr
PRIVATE oldrecnum
IF EOF()
    SKIP - 1
ENDIF
oldrecnum = RECNO()
LOCATE FOR &expr
IF EOF()
    DO alert WITH msg_loc1 
    GOTO oldrecnum
    continueon = .F. 
    expr = '' 
ELSE
    continueon = .T. 
ENDIF
RETURN

* --- Procedure called when Continue is chosen from the Go menu

PROCEDURE docont
PRIVATE oldrecnum
oldrecnum = RECNO()
CONTINUE
IF EOF()
    DO alert WITH msg_eof 
    GOTO oldrecnum
    continueon = .F. 
ELSE
    continueon = .T. 
ENDIF
RETURN

* --- Procedure called when an execution error occurs

PROCEDURE doerror
PARAMETER errnum,errmes
<<if ismultials>>
temparea = STR(dbfarea)
<<endif>>
answer = 1
sterrnum = SPACE(1)+ALLTRIM(STR(errnum))+SPACE(1)
DO CASE

    *--- Non-critical errors
    CASE sterrnum $ ' 1 50 54 124 125 1105 1112 ' .OR. (errnum > 1240 .AND. errnum < 1247)
        DO alert WITH errmes 
        RETURN

    *--- EOF error
    CASE errnum = 4
<<forall databases>>
        IF RECCOUNT({dbfcount}) = 0 
            answer = 1 
            DO alert2 WITH answer,DBF({dbfcount})+ msg_addrec
            IF answer = 1
        <<if ismultials>>
                SELECT {dbfcount}
        <<endif>>
                APPEND BLANK
        <<if ismultials>>
                SELECT &temparea
		<<endif>>
                RETRY
           ELSE
                DO alert WITH msg_fatal 
                mexit = .T.
                DO closedown
                CANCEL
           ENDIF
        ENDIF
    <<forall relations>>
        IF EOF({"}{relals}{"})
            answer = 1
            DO alert2 WITH answer, 'No matching record in '+DBF({"}{relals}{"})+' add ?' 
            IF answer = 1
                SELECT {relals}
                APPEND BLANK
                SELECT &temparea
                RETRY
            ENDIF
            CLEAR GETS
            DEACTIVATE MENU
        ENDIF
    <<endfor>>
<<endfor>>
        DEACTIVATE MENU

    *--- Critical errors causing program termination

    OTHERWISE
        
        DO alert WITH msg_fatal 
        
        * --- Restore initial environment
        DO closedown
        CANCEL
ENDCASE

* --- Procedure called when the Esc key is pressed; you are given the option
* --- to quit this program

PROCEDURE doescape
answer = 1
DO alert2 WITH answer, msg_stop 
IF answer = 1
   DO closedown
   CANCEL
ENDIF
ACTIVATE SCREEN
RETURN

* --- restore environment settings before quitting

PROCEDURE closedown
ON ESCAPE
ON ERROR
CLOSE ALL
SET HELP TO
SET COLOR TO
CLEAR
CLEAR WINDOWS
SET PROCEDURE TO
SET SAFETY &menv_safe
SET BELL &menv_bell
SET HELP &menv_help
SET STATUS &menv_stat
SET FULLPATH &menv_full
SET ESCAPE &menv_esca
SET DELETED &menv_dele
SET CLOCK &menv_cloc
SET ECHO &menv_echo
SET TALK &menv_talk
SET DEBUG &menv_debu
SET COLOR OF SCHEME 2 TO
RETURN

* --- Removes all non-alpha characters from a string replacing them 
* --- with a space

FUNCTION alphaonly
PARAMETER msource
mlen = LEN(msource)
mtarget = ''
FOR ms = 1 TO mlen
    mtarget = mtarget + IIF(ISALPHA(SUBSTR(msource,ms,1)),SUBSTR(msource,ms,1),' ')
ENDFOR
RETURN mtarget

* --- This procedure builds the online Help file if one is not present

PROCEDURE domemo
PRIVATE mftemp
mftemp = SYS(3)+'.DBF'
COPY TO &mftemp STRUCTURE EXTENDED
USE (mftemp) EXCLUSIVE
ZAP
APPEND BLANK
REPLACE field_name WITH 'TOPIC',field_type WITH 'Character',field_len WITH 30
APPEND BLANK
REPLACE field_name WITH 'DETAILS',field_type WITH 'Memo',field_len WITH 10
USE
CREATE {fileprefix}_help.dbf FROM &mftemp
DELETE FILE (mftemp)
USE {fileprefix}_help
mhelpno = 23
DIMENSION hlp_text[mhelpno,2]
hlp_text[1,1] = '   <<< FILE MENU >>> '
hlp_text[1,2] = 'The File menu contains Help, Database, and Quit options.  For more information on these options, choose the appropriate topic in this Help facility.'
hlp_text[2,1] = ' - Help'
hlp_text[2,2] = 'Choosing Help displays the Help window with a list of available help topics.  Choose a topic to see more information on that topic.'
hlp_text[3,1] = ' - Database'
hlp_text[3,2] = 'This option is enabled when you have more than one database open.  When you choose the Database... option a list of open databases is displayed.  Select the database you wish to make active.'
hlp_text[4,1] = ' - Quit '
hlp_text[4,2] = 'Exit this program. '
hlp_text[5,1] = '   <<< GO MENU >>>'
hlp_text[5,2] = 'The Go menu contains Seek, Goto, Locate, Continue, Next, Prior, Top and Bottom options.  For more information on one of these options, choose the appropriate topic in this Help facility.'
hlp_text[6,1] = ' - Seek'
hlp_text[6,2] = 'Seek is enabled when an index is active.  This option searches the database for a record that matches the expression you create.'
hlp_text[7,1] = ' - Goto'
hlp_text[7,2] = 'When you choose Goto..., a dialog appears so you can move the record pointer to the top or bottom of the active database or to a specific record number.'
hlp_text[8,1] = ' - Locate'
hlp_text[8,2] = 'The database will be searched for a record that matches the expression you create in the expression builder.  The expression must be logical, and the database need not be indexed.'
hlp_text[9,1] = ' - Continue'
hlp_text[9,2] = 'If a Locate is successful, the Continue option will be available.  You may then search for the next record that matches the expression you created with the Locate option.'
hlp_text[10,1] = ' - Next'
hlp_text[10,2] = 'Choose this option to move the record pointer to the next record in the database.'
hlp_text[11,1] = ' - Prior'
hlp_text[11,2] = 'Choose this option to move the record pointer to the previous record in the database.'
hlp_text[12,1] = ' - Top'
hlp_text[12,2] = 'Choose this option to move the record pointer to the top of the database.'
hlp_text[13,1] = ' - Bottom'
hlp_text[13,2] = 'Choose this option to move the record pointer to the last record in the database.'
hlp_text[14,1] = '   <<< RECORD MENU >>>'
hlp_text[14,2] = 'The Record menu contains the Edit, Add, Browse and Delete options.  For more information on one of these options, choose the appropriate topic in this Help facility.'
hlp_text[15,1] = ' - Edit'
hlp_text[15,2] = 'Choose this option to edit the current record.'
hlp_text[16,1] = ' - Add'
hlp_text[16,2] = 'This option allows you to add a blank record to the database.'
hlp_text[17,1] = ' - Browse'
hlp_text[17,2] = 'Choosing the Browse option opens a Browse window for the database.  In Browse you may view and edit records, and add and delete records.'
hlp_text[18,1] = ' - Delete Recall'
hlp_text[18,2] = 'You may delete the current record by choosing this option.  When a record is marked for deletion, this option changes to Recall, and the record may then be reactivated.'
hlp_text[19,1] = '   <<< UTILITIES MENU >>>'
hlp_text[19,2] = 'The Utilities menu contains the Report, Label, Pack and Reindex options.  For more information on one of these options, choose the appropriate topic in this Help facility.'
hlp_text[20,1] = ' - Report'
hlp_text[20,2] = 'You may create, modify, or print a report by choosing this option.  A Report layout window is opened where you may set up or modify a report.'
hlp_text[21,1] = ' - Label'
hlp_text[21,2] = 'You may create, modify, or print labels by choosing this option.  A Label layout window is opened where you may set up or modify labels.'
hlp_text[22,1] = ' - Pack'
hlp_text[22,2] = 'Choosing the Pack option removes all records from the current database that are marked for deletion.  You may mark records to be deleted with the Delete option of the Record menu.'
hlp_text[23,1] = ' - Reindex'
hlp_text[23,2] = 'The Reindex option is used to update indexes that were not open when records were added or deleted from a database file.'
* --- build database from array
FOR mx = 1 TO mhelpno
    APPEND BLANK
    REPLACE topic WITH hlp_text[mx,1],;
    details WITH ALLTRIM(ALPHAONLY(PROPER(hlp_text[mx,1])))+CHR(13)+hlp_text[mx,2]
NEXT
RETURN

<<end>> <<*GenProcStandard*>>

<<* Get index file names *>>

<<#
function GetIndexNames( indexchoice : integer ) : string
string ndxnames,fpath,fname,fext
begin
    <<*--Start with selected index--*>>
    select index indexchoice
    filespec(ndxnam,fpath,fname,fext)
    ndxnames := '"'+fname+'.'+fext+'"'
    forall indexes
        if ndxcount <> indexchoice
            filespec(ndxnam,fpath,fname,fext)
            ndxnames := ndxnames+ ',' + '"' + fname + '.' + fext + '"'
        endif
    endfor
    return ndxnames
end GetIndexNames
#>>

<<procedure GenSEEK>>
<<begin>>

* --- Procedure called when Seek is chosen from the Go menu 

PROCEDURE {fileprefix}_seek
PRIVATE seekexpr
IF .NOT. hasindex(dbfarea) 
    DO alert WITH "No Order Set. Can't Seek."
    RETURN
ENDIF
ndxkey = SYS(14,1,dbfarea)
ndxtype = TYPE(ndxkey)
IF ndxtype <> 'U'
    GETEXPR "Value to SEEK <expc> (index = " +ndxkey + ")" TO seekexpr TYPE ndxtype
    IF '' <> TRIM(seekexpr) 
        mrecno = RECNO() 
        SEEK &seekexpr
        IF EOF()
            DO alert WITH msg_nofind
            GOTO mrecno
        ENDIF
    ENDIF
ELSE
    DO alert WITH msg_illkey
ENDIF
RETURN
<<end>> <<*GenSEEK*>>

<<#

<<* Check for index present *>>

procedure GenProcSecond
begin
    select all
    if ndxtotal > 0 <<*Total ndxs for entire system*>>
        GenSEEK
    endif
end>> <<*genProcSecond*>>
#>>

    
