<<* SIMUTIL.INC *>>
<<#pragma

procedure DisplayFormat
string box
begin
  forall fldlab
    if fldtyp = 'B'  <<*BOX Type*>>
      box := fldlab  <<*Used to swap chars for Character box*>>
      gen( '   @ ',fldrow,',',fldcol,',' )
      gen( fldrow+flddec,',',fldcol+fldwid,' BOX "' )
      genln( substr(box,1,3),box[5],box[8],box[7],box[6],box[4],'"' )
    else  <<*All Fields and Text Objects*>>
      genln( '   @ ',fldrow,',',fldcol,' SAY "',fldlab,'"' )
    endif
  endfor
end <<*DisplayFormat*>>


procedure GenPicture
string picstrg
begin
  if fldpic
    gen( ' PICTURE "',fldpic,'"' )
  elsif fldtyp = 'N'  <<*Force numeric picture*>>
    picstrg := replicate( '9',fldwid )
    if flddec
      picstrg[ fldwid-flddec ] := '.'
    endif
    gen( ' PICTURE "',picstrg,'"' )
  endif
end <<*GenPicture*>>


procedure DisplayRecord
begin
  <<*---Only Char, Date, Logical, & Numeric fields---*>>
  forall fldtyp $ 'CDLN'
    if fldhor  <<*field on the side of label*>>
      gen( '   @ ',fldrow,',',fldcol + len(fldlab),' GET ',fldnam )
    else  <<*field below label*>>
      gen( '   @ ',fldrow + 1,',',fldcol,' GET ',fldnam )
    endif
    GenPicture
    genln  <<*Send CR/LF*>>
  endfor
end <<*DisplayRecord*>>


procedure EditRecord( IsAutoMem : logical )
begin
  forall fldget and (fldtyp $ 'CDLN')
    gen( space(3) )
    if fldhor
      gen( '@ ',fldrow,',',fldcol+len(fldlab),' GET ' )
    else
      gen( '@ ',fldrow+1,',',fldcol,' GET ' )
    endif
    if IsAutoMem
      gen( 'm' )
    endif
    gen( fldnam )
    GenPicture
    if fldran
      gen( ' RANGE ',fldran )
    elsif fldval
      gen( ' VALID(',fldval,')' )
    endif
    genln  <<*Send CR/LF*>>
  endfor
end <<*EditRecord*>>


function DefaultVal : string
begin
  if fldtyp = 'C'
    RETURN 'SPACE( ' + str( fldwid ) + ' )'
  elsif fldtyp = 'N'
    RETURN '0.00'
  elsif fldtyp = 'D'
    RETURN 'DATE()'
  else
    RETURN '.F.'
  endif
end <<*DefaultVal*>>


procedure BlankRecord
string temp
begin
  forall fldget and (fldtyp $ 'CDLN')
    if fldini
      genln( '   m',fldnam,' = ',fldini )
    else
      temp := DefaultVal
      genln( '   m',fldnam,' = ',temp )
    endif
  endfor
end <<*BlankRecord*>>

<<* SIMUTIL.INC *>>
#>>
